QGIS Application - Feature request #17273
Respect coordinate system (CRS) when outputFormat=GeoJSON
2017-10-13 09:56 AM - Henrik Uggla

Status: Feedback

Priority: Low

Assignee:

Category: QGIS Server

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 25171
Description

Following request returns correct coordinate system:

http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;typename=fastyt
&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmins:ogc=%22http://www.opengis.net/0gc%22%3E%3Cogc:Property

sEqual

ylsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3

EJULT(

EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertylsEqualTo%3E%3C/ogc:Filter%3E

Add outputFormat=GeoJSON and wrong coordinate system is returned:

http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WF S&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;outputFormat=G
0JSON&#38;typename=fastyta &#38;width=1600&#38;height=6608&#38;filter=%3Cogc:Filter%20xmIins:ogc=%22http://www.opengis.net

00C%2

t/09¢c%22%3E%3Cogc:PropertylsEqual To%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:Propert

Name

rtyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertylsEqual To%3E%3C/ogc:Filter%3E

This doesn't happen in 2.14

History

#1 - 2017-10-13 11:07 AM - Richard Duivenvoorde

Hi Henrik,

Officially Geojson is always in epsg:4326 / lat lon coordinates:
https://tools.ietf.org/html/rfc7946#page-12

And | see that QGIS reprojects your data nicely (both version gml and json fit exactly)

Not sure if that is the reason QGIS always returns it, but it could be the reason that the older QGIS followed the older spec (see the spec text).
| agree that sometimes it can be helpfull to have the original coordinates though... maybe discuss an optional switch?

Does geoserver still return different crs's?

#2 - 2017-10-13 11:10 AM - Giovanni Manghi
- Status changed from Open to Feedback

#3 - 2017-10-13 11:45 AM - Henrik Uggla
- Status changed from Feedback to Open

We are using Geoserver 2.11.0 (latest is 2.11.2) and it does return different crs's.
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;outputFormat=GeoJSON&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;outputFormat=GeoJSON&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;outputFormat=GeoJSON&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
http://193.17.67.229/cgi-bin/fastighetsindelning/?service=WFS&#38;request=GetFeature&#38;SRS=EPSG:3008&#38;outputFormat=GeoJSON&#38;typename=fastyta_&#38;width=1600&#38;height=660&#38;filter=%3Cogc:Filter%20xmlns:ogc=%22http://www.opengis.net/ogc%22%3E%3Cogc:PropertyIsEqualTo%20matchCase=%22false%22%3E%3Cogc:PropertyName%3EFASTIGHET%3C/ogc:PropertyName%3E%3Cogc:Literal%3EJULTOMTEN%203%3C/ogc:Literal%3E%3C/ogc:PropertyIsEqualTo%3E%3C/ogc:Filter%3E
https://tools.ietf.org/html/rfc7946#page-12

#4 - 2017-10-20 10:14 AM - René-Luc ReLuc

To support different's CRSs in WFS, QGIS Server needs to implement WFS 1.1.0.

It's not a regression because, QGIS Server does not specify the CRS in the GeoJSON output.

And the QgsJSONUils has been designed to strictly respect the GeoJSON ISO specification https://qgis.org/api/2.18/classQgsJSONULtils.html

So if you want that QGIS Server (and QGIS) can generate GeoJSON in an other CRSs, the QgsJsonUstils has to be updated and used in WFS 1.1.0
implemented in QGIS 3.

#5 - 2017-10-20 10:24 AM - Giovanni Manghi
- Status changed from Open to Feedback

René-Luc RelLuc wrote:

To support different's CRSs in WFS, QGIS Server needs to implement WFS 1.1.0.

It's not a regression because, QGIS Server does not specify the CRS in the GeoJSON output.

And the QgsJSONUIils has been designed to strictly respect the GeoJSON ISO specification https.//qqgis.org/api/2.18/classQgsJSONUtils.html

So if you want that QGIS Server (and QGIS) can generate GeoJSON in an other CRSs, the QgsJsonUltils has to be updated and used in WFS 1.1.0
implemented in QGIS 3.

so this should be a feature request instead?

#6 - 2018-04-04 11:01 AM - Alessandro Pasotti

- Priority changed from High to Low

- Tracker changed from Bug report to Feature request

- Subject changed from Qgis Server WFS returns wrong coordinate system when outputFormat=GeoJSON to Respect coordinate system (CRS) when
outputFormat=GeoJSON

Changed to feature request with low priority.
https://qgis.org/api/2.18/classQgsJSONUtils.html
https://qgis.org/api/2.18/classQgsJSONUtils.html

